__author__  = '''Rocky Burt <rocky@serverzen.com>'''
__docformat__ = 'plaintext'

__all__ = ('log', 'logEx', 'updatePAS')

from Products.SQLPASPlugin import config

import zLOG
def log(msg, severity=zLOG.INFO):
    zLOG.LOG('SQLPASPlugin', severity, msg)
def logEx(msg, severity=zLOG.INFO):
    zLOG.LOG('SQLPASPlugin', severity, msg, error=True)
    
    
def _debug(msg, out):
    if out:
        print >> out, msg
    log(msg)

def updatePAS(context, sql_connection, out=None):
    """This method retrieves the current context's acl_users, ensures
    that it is indeed a PAS instance, and then goes ahead and sets
    up SQLPASPlugin in that PAS instance (if it is actually a PAS instance).
    """
    
    uf = context.acl_users
    if uf.meta_type == 'Pluggable Auth Service':
        if out:
            print >> out, "Found pluggable auth service instance"


        # Lets setup the SQLUserManager PAS plugin
        usersId = config.USERMANAGER_ID
        if usersId in uf.objectIds():
            if out:
                print >> out, 'Deleting "%s"...' % usersId
            uf.manage_delObjects([usersId])
        else:
            if out:
                print >> out, 'Deletion of "%s" not necessary' % usersId

        addSQLUserManager = uf.manage_addProduct['SQLPASPlugin'] \
            .manage_addSQLUserManager
        addSQLUserManager(id=usersId, sql_connection=sql_connection)
        
        plugin = uf[usersId]
        plugin.manage_activateInterfaces(['IAuthenticationPlugin', 
                                          'IUserEnumerationPlugin', 
                                          'IUserAdderPlugin',])


        propsId = config.PROPERTYPROVIDER_ID
        if propsId in uf.objectIds():
            if out:
                print >> out, 'Deleting "%s"...' % propsId
            uf.manage_delObjects([propsId])
        else:
            if out:
                print >> out, 'Deletion of "%s" not necessary' % propsId
        addSQLPropertyProvider = uf.manage_addProduct['SQLPASPlugin'] \
            .manage_addSQLPropertyProvider
        addSQLPropertyProvider(id=propsId, sql_connection=sql_connection)
        
        plugin = uf[propsId]
        plugin.manage_activateInterfaces(['IPropertiesPlugin', 
                                          'IUpdatePlugin'])


    else:
        if out:
            print >> out, "Didn't find a pluggable auth service instance"

    
    
